import type { Waypoint } from '../shared/types';

export type Marker = Waypoint & {
    key: string;
    remove: () => void;
    moveUp: () => void;
    moveDown: () => void;
    changeLongLabel: (newLongLabel: string) => void;
    /**
     * Should be at most 1-2 characters (to be displayed on map markers), can change at any time
     */
    shortLabel: string;
    /**
     * Displayed in the list, should only change when explicitly requested by user
     */
    longLabel: string;
};

export type ReorderListParams = {
    oldIndex: number;
    newIndex: number;
};
